const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Payment_transactionsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const payment_transactions = await db.payment_transactions.create(
      {
        id: data.id || undefined,

        amount_cents: data.amount_cents || null,
        currency: data.currency || null,
        psp_provider: data.psp_provider || null,
        psp_txn_id: data.psp_txn_id || null,
        status: data.status || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await payment_transactions.setSubscription(data.subscription || null, {
      transaction,
    });

    await payment_transactions.setOrganizations(data.organizations || null, {
      transaction,
    });

    return payment_transactions;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const payment_transactionsData = data.map((item, index) => ({
      id: item.id || undefined,

      amount_cents: item.amount_cents || null,
      currency: item.currency || null,
      psp_provider: item.psp_provider || null,
      psp_txn_id: item.psp_txn_id || null,
      status: item.status || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const payment_transactions = await db.payment_transactions.bulkCreate(
      payment_transactionsData,
      { transaction },
    );

    // For each item created, replace relation files

    return payment_transactions;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const payment_transactions = await db.payment_transactions.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.amount_cents !== undefined)
      updatePayload.amount_cents = data.amount_cents;

    if (data.currency !== undefined) updatePayload.currency = data.currency;

    if (data.psp_provider !== undefined)
      updatePayload.psp_provider = data.psp_provider;

    if (data.psp_txn_id !== undefined)
      updatePayload.psp_txn_id = data.psp_txn_id;

    if (data.status !== undefined) updatePayload.status = data.status;

    updatePayload.updatedById = currentUser.id;

    await payment_transactions.update(updatePayload, { transaction });

    if (data.subscription !== undefined) {
      await payment_transactions.setSubscription(
        data.subscription,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await payment_transactions.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return payment_transactions;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const payment_transactions = await db.payment_transactions.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of payment_transactions) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of payment_transactions) {
        await record.destroy({ transaction });
      }
    });

    return payment_transactions;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const payment_transactions = await db.payment_transactions.findByPk(
      id,
      options,
    );

    await payment_transactions.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await payment_transactions.destroy({
      transaction,
    });

    return payment_transactions;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const payment_transactions = await db.payment_transactions.findOne(
      { where },
      { transaction },
    );

    if (!payment_transactions) {
      return payment_transactions;
    }

    const output = payment_transactions.get({ plain: true });

    output.subscription = await payment_transactions.getSubscription({
      transaction,
    });

    output.organizations = await payment_transactions.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.subscriptions,
        as: 'subscription',

        where: filter.subscription
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.subscription
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  status: {
                    [Op.or]: filter.subscription
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.currency) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'payment_transactions',
            'currency',
            filter.currency,
          ),
        };
      }

      if (filter.psp_txn_id) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'payment_transactions',
            'psp_txn_id',
            filter.psp_txn_id,
          ),
        };
      }

      if (filter.amount_centsRange) {
        const [start, end] = filter.amount_centsRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            amount_cents: {
              ...where.amount_cents,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            amount_cents: {
              ...where.amount_cents,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.psp_provider) {
        where = {
          ...where,
          psp_provider: filter.psp_provider,
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.payment_transactions.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('payment_transactions', 'psp_txn_id', query),
        ],
      };
    }

    const records = await db.payment_transactions.findAll({
      attributes: ['id', 'psp_txn_id'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['psp_txn_id', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.psp_txn_id,
    }));
  }
};
